#define PWIDTH 32   /* puts it on a boundary so far pointers work better */
typedef struct s_run {
	unsigned char *alloc; /* Array, Num of allocated bytes for row */
	unsigned char *used; /* Number currently used */
	int *(*row)[];  /* Pointer, to array of pointers to row count data */
} Run;

typedef unsigned char *ucharp;
typedef int *(*typrow)[];
typedef struct bitmap {
	char *(*data)[];
        int compress;
	int nx,ny;
	int x1,y1,sx,sy,lddy,sddy,lendx,lendy,ssx,ssy;
	Run clip;
	int clipping;
	int *lastclip;
	Run paint;
	Run horiz;
	int painty1,painty2;
	int32 lstyle,lstyle_mask;
        int lstyle_dotlen, lstyle_dotpix;
	int lwidth;
	char ink[16][16];
} Bitmap;

Bitmap *bmp_open(int xsize,int ysize,int depth, int bmp_compress);
void row_init(Run *r, int ny);
void row_free(Run *r, int ny);
void row_shrink(Bitmap *b);
void row_shrinkx(Run *r, int ny);
void row_grow(Run *r, int y, int v);
void iffree(void *block);
void bmp_close(Bitmap *b);
void bmp_line(Bitmap *b,int x1,int y1,int x2,int y2);
void bmp_pixel(register Bitmap *b,register int x,register int y);
void bmp_paintrange(Bitmap *b,int y, register int x1, int x2);
int bmp_invis(Bitmap *b, int x, int y);
void bmp_pmove(Bitmap *b,int x1,int y1);
void bmp_pline(Bitmap *b,int x2,int y2);
void bmp_minmax(Bitmap *b,int y);
void bmpcheck(Bitmap *b);
void bmp_paintx(Bitmap *b, int x, int y);
void row_show(char *s,Run *r,int y);
void showhy(Bitmap *b, int y);
void bmp_painth(Bitmap *b, int x1,int x2, int y);
void bmp_newpath(Bitmap *b);
void bmp_paintsort(int *p, int np);
void bmp_fill(Bitmap *b);
void bmp_copy(Bitmap *b,char *bitmap,int nx,int ny);
void bmp_clip(Bitmap *b);
void bmp_newclip(Bitmap *b);
void bmp_saveclip(Bitmap *b);
void bmp_restoreclip(Bitmap *b);
void bmp_color(Bitmap *b,int colindex);
void bmp_setcolor(Bitmap *bb,int r, int g, int b, int ftyp);
void bmp_ink4(Bitmap *bb,unsigned int savem,int cindex);
void bmp_ink16(Bitmap *bb,unsigned int newink[],int cindex);
void bmp_lwidth(Bitmap *b,int x);
void  bmp_lstyle(Bitmap *b,int32 n,int l);
void bmp_pattern(Bitmap *b,char *pat,int nxbytes,int nybytes,int depth);
char *bmp_row(Bitmap *b,int y);
unsigned char *bmp_expanded(Bitmap *b,int y);
void bmp_die(char *s);
void bmp_pbezier(Bitmap *bb,int x0, int y0, int x1, int y1, int x2, int y2, int x3, int y3);
void bmp_bezier(Bitmap *bb,int x0, int y0, int x1, int y1, int x2, int y2, int x3, int y3);
int bmp_clipline(Bitmap *b,int *x1, int *y1, int *x2, int *y2);
void doclip(int min, int max, int *v);
void showfree(void);

