#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <assert.h>
#include "int32.h"

#ifndef unix
#include <stdarg.h>
#endif

#ifdef __VMS
#include "VMS.H"
#define unlink(x) (void) delete(x)
void getch(void);
#endif
#ifdef __TURBOC__
#else
#define farcalloc calloc
#define farfree free
#endif

#ifdef DJ                       /* a.r. */
#define clrscr ScreenClear
#endif

#ifdef EMXOS2                   /* a.r. */
#define delline v_delline
#define clreol  v_clreol
#define putch   v_putc
#define cputs   v_puts
#endif

#define gprint (void) printf
#define myfree (void) free
#define true (!false)
#define false 0

struct s_range {int col,row,c1,r1,c2,r2,colfirst; };
typedef struct s_range RANGE;

char *range_int(char *s, int *v);
extern int gle_debug;
typedef char (*(*TOKENS)[500]);
typedef unsigned char uchar;
typedef double dbl;
char *unquote(char *s);
char *gledir(char *s);
int set_missing(int x, int y);
int strcpydecimal(char *dest, char *src, int wid, int dpoints);
int strcpywidth(char *dest, char *src, int wid);
int range_def(char *s, RANGE *r);
int alloc_temp(int n);
int text_inkey(void);
#ifndef unix
void wprintf(va_list arg_list, ...);
void fner(va_list arg_list, ...);
void printmess(va_list arg_list, ...);
#endif
char *sdup(char *s);
/* void myfree(void *p); */
void myfrees(void *p, char *s);
void *myallocn(int32 nitems,int32 size);
void *myalloc(int32 size);
void *myallocz(int32 size);
int showpcode(int32 *p);
int add_fn(char *pcode, int *plen, int i);
int add_i(char *pcode,int *plen,int32 i);
int add_f(char *pcode,int *plen,double f);
int add_pcode(char *pcode,int *plen,char *fcode,int *flen);
int add_string(char *pcode, int *plen, char *s);
#ifndef __TURBOC__
#ifndef __GNUC__ /* a.r. */
char *strdup(char *);
#endif
#endif
int add_var(char *pcode,int *plen,int i);
char *eval_str(int32 *pcode,int *plen);
char *find_non_space(char *cp);
char *find_term(char *cp);
char *un_quote(char *ct);
int isnumber(char *s);
int lastchar(char *s, char c);
int mystrcpy(char **d,char *s);
int scheck(int v);
int spop(int v);
int spush(int v);
int stack_op(char *pcode, int *plen, int stk[] ,int stkp[], int *nstk,  int i, int p);

void refresh(void);
int read_str(int *cmd, char *s);
int xy_polar(double dx,double dy,double *radius,double *angle);

/*pieces from cell.c*/

void set_usefloat(void);
void data_expand(int x, int y);
void clear_data(void);
void set_size(int x, int y);
void data_setsize(int x, int y);
void xdata_setsize(int x, int y,int mx,int my);
void set_scell(int x, int y, char *s);
void set_cell(int x, int y, double d);
int cell_greater(int x1,int y1, int x2, int y2);
char *scell(int x, int y);
double vcell(int x, int y);
void get_cell(int x, int y, double *v);
void copy_cell(int x, int y, int x2, int y2);
void swap_cell(int x, int y, int x2, int y2);
void clear_cell(int x, int y);
void get_cellboth(int x, int y, double *v, char **s);
void trim_data(void);

/* pieces from manip.c */
void top_line(void);
void gle_abort(char *s);
void set_newxy(int x, int y);
void set_colwidth(int n);
void set_ncol(int n);
int read_command(int *cmd,char *ans,char *ques);
void do_arrow(int k);
void hi_cell(int x,int y);
void fix_cur(void);
void text_save(void);
void window_norm(void);
void window_exit(void);
void gotocell(int x, int y);
void show_cell(int x, int y);
void show_ifcell(int x, int y);
void fner_clear(void);
void show_cellwide(int x, int y);
void fnerx(char *s);
void fnerxx(char *s);
void d_tidyup(void);
void command_scroll_up(void);
int text_changed(void);


/* pieces from cmd.c */
void do_command(char *cmd);
void at_open(char *fname);
void cmd_load(char *fname, char *range, int ntok);
void cmd_load_list(RANGE *r, char *inbuff);
void cmd_load_line(int x, int y, char *inbuff);
void cmd_save(char *fname, char *range, char *format, int ntok);
void cmd_copy(char *src, char *dest, char *ifexp, int ntok, int always);
void cmd_generate(char *patx, char *dest, int ntok);
void cmd_polish(char *exp);
void cmd_eval(int x1, int y1, double *v);
void cmd_delete(char *range, char *ifexp, int ntok);
void cmd_sort(char *range, char *ifexp, int ntok);
void cmd_insert(char *range);
void cmd_data(char *range);
void cmd_swap(char *range);
void cmd_parsum(char *range, char *dest);
void cmd_sum(char *range);
void cmd_clear(char *range);
void cmd_fit(char *range);
void set_outwidth(char *s);
void log_write(char *s);
void log_open(char *fname);
void log_close(void);
void evaluate(char *exp, double *v);
void strip_colon(char *s);
void swapint(int *a, int *b);
void load_str(int x, int y, char *s);
int at_read(char *s);


/* pieces from general.c */
void ncpy(char *d, char *s, int n);

/* pieces from var.c */
void var_check(int *j);
void var_alloc_local(void);
void var_free_local(void);
void var_set(int jj, double v);
void var_setstr(int jj, char *s);
void var_getstr(int jj, char *s);
void var_get(int jj, double *v);
void var_nlocal(int *l);
void var_clear_global(void);
void var_set_local(void);
void var_set_global(void);
void var_clear_local(void);
void var_findadd(char *name,int *idx,int *type); /* Add a variable to the list */
void var_add(char *name,int *idx,int *type);     /* Add a variable to the list */
void var_find(char *name,int *idx,int *type);    /* Find a variable in the list */
void var_find_dn(int *idx, int *var, int *nd);
void var_find_rc(int *idx, int *var, int *nd, int c);



/* pieces from token.c */
void token_norm(void);
void token_space(void);
void token_equal(void);
void token_init(void);
void token(char *lin,char *tok[],int *ntok,char *outbuff);
void subscript(void);

/* pieces from sub.c */
void sub_param(int idx,char *s);
int sub_find(char *s,int *idx,int *zret, int *np, int **plist);
void sub_clear(void);
int sub_def(char *s);
void sub_set_startend(int idx, int ss, int ee);
void sub_get_startend(int idx, int *ss, int *ee);
void sub_call(int idx,double *pval,char **pstr,int *npm);
void sub_set_return(double d);

/* pieces from keyword.c */
void cmd_name(int idx, char **cp);
void find_mkey(char *cp, int *idx);
int find_primcmd(char *cp);
 
/* pieces from filemenu.c */
void do_help(char *k1, char *k2);
int pick_file(char *result, char *wld);


/* pieces from vaxscr.c */
void window(int left,int top, int right, int bottom);
void clrscr(void);

/* pieces from eval.c */
void eval(int32 *pcode,int *cp,double *oval,char *ostr,int *otyp);
void eval_setxy(double  x, double  y);
void eval_setxyd(double x, double y);
void debug_polish(int32 *pcode,int *zcp);
char *eval_str(int32 *pcode,int *plen);
void setdstr(char **s,char *in);
void eval_setxy(double x, double y);
void eval_setxyd(double x, double y);

/* pieces from polish.c */
void polish(char *expr,char *pcode,int *plen,int *rtype);

/* pieces from mjl.c */
void init_logging(char *infile);
void mjl_key(int c);
void mjl_flush(void);

/* pieces from fn.c */
void find_un(char *cp, int *idx,int *ret,int *np,int **plist);

